#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// 1a
/*
Definiálj típust valós számokat tároló bináris rendezőfa (keresőfa) elemeihez.
Írj függvényt, mely meghatározza a paraméterként kapott nemüres rendezőfában tárolt legnagyobb értéket!
*/
typedef struct tree {
    double data;
    struct tree* left, * right;
} tree;

double max(tree* root) {
    while (root->right != NULL)
        root = root->right;
    return root->data;
}

// 1b

// Hozz létre függvénypointert, mely rámutat az stdlib.h könyvtár free függvényére.
void (*f)(void*) = free;
// vagy
// void (*f)(void*);
// f = free;

// 1c
// Írj függvényt, mely kicserél két paraméterként kapott intet.
void swap(int* a, int* b) {
    int tmp = *a;
    *a = *b;
    *b = tmp;
}

// d
// Deklarálj függvényt, mely egy olyan 2D double-tömböt vesz át paraméterként, melynek belső mérete 8, és visszaad egy pointert a tömb legnagyobb elemére.
// (csak a függvény fejlécét kell megadnod)
double *max_element(double array[][8], int n);
// vagy
double *max_element(double (*array)[8], int n);

// 2 - 10 pont

/*
Írj függvényt, mely egy sztringet kap paraméterként.
A bejövő sztring magyar szöveget tárol, de az ékezetes karaktereket ún. ,,repülő karakteres'' kódolással ábrázolja.
A repülő karakteres kódolás az ékezetekes karaktereket a magánhangzót megelőző aposztróffal, kettősponttal vagy macskakörömmel ábrázolja az alábbi példa által mutatott módon:
'arv'izt"ur"o t:uk:orf'ur'og'ep
A függvény feladata a repülő karakteres szöveget ,,távirati stílusra'' fordítani, ami kizárólag az angol ábécé betűit használja.
A fenti példaszöveg távirati stílusú megfelelője
aarviiztueueroeoe tuekoerfuuroogeep
A függvény feladata az eredménysztringnek dinamikusan memóriát foglalni, abban a szöveget előállítani, és azt visszaadni.
A sztring méretének meghatározásához azt figyeld meg, hogy az egyes repülő előtagok hány pluszkaraktert eredményeznek a szövegben.
*/

// 
char* convert(char* s) {                    
    int j = 0;
    for (int i = 0; s[i] != '\0'; i++, j++) 
        if (s[i] == '\"') 
            j += 2;
    char* result = (char*)malloc(sizeof(char) * (j + 1));
    j = 0;
    for (int i = 0; s[i] != '\0'; i++) {
        switch (s[i]) {
            case '\"':
                i++;
                result[j] = result[j+2] = s[i];
                result[j+1] = result[j+3] = 'e';
                j += 4;
                break;
            case '\'':
                i++;
                result[j++] = result[j++] = s[i];
                break;
            case ':':
                result[j++] = s[i++];   
                result[j++] = 'e';
                break;
            default:
                result[j++] = s[i];
        }
    }
    result[j] = '\0';                   
    return result;                      
}


// 3 - 12 pont

/*
A Mikulás puttonyában csoki, cukor és virgács van, ezeket egy elölstrázsás, egyirányban láncolt listában tárolja.

a) Definiálj listaelem típust.
A tárolt adat (csoki / cukor / virgács) felsorolt típusú legyen.

b) Írj függvényt, mely a paraméterként kapott listából a virgácsokat kitörli (fel is szabadítja), a cukrokat pedig új, azonos szerkezetű listába láncolja át.
Így az eredeti listában csak a csokik maradnak.
A függvény feladata a cukorlista strázsájának foglalása, de az eredeti lista cukorelemeiről nem készíthet másolatot, azokat az új listába át kell láncolnia, az eredetivel azonos sorrendben.
A függvény adja vissza a cukorlista strázsájának címét.
*/

// típus: 2 pont
typedef struct list {
    enum {chocolate, candy, birch} data;
    struct list* next;
} list;

list* process(list* head) {                     
    list* new = (list*)malloc(sizeof(list));    
    new->next = NULL;
    list* p = new;
    while (head->next != NULL) {                
        switch (head->next->data) {
            case birch: {                       
                list* tmp = head->next;         
                head->next = head->next->next;  
                free(tmp);                      
                break;
            }
            case candy:                         
                p->next = head->next;           
                head->next = head->next->next;  
                p->next->next = NULL;           
                p = p->next;
                break;
            case chocolate:                     
                head = head->next;              
        }
    }
    return new;                                 
}


// 4 - 10 pont

/*
Egy bináris fájl egy színház téglalap elrendezésű nézőterének foglaltsági adatait tartalmazza.
A fájl első két int adata rendre a sorok számát és az egy soron belüli székek számát adja meg.
Az ezt követő int bejegyzések az egyes székek foglaltsági adatait tartalmazzák sorfolytonosan (0: szabad, 1: foglalt).
A sorfolytonos tárolás azt jelenti, hogy az első sor összes székének foglaltsági adatait követik a második sor székei és így tovább.
*/

/*
a) Írj függvényt, mely a paraméterként kapott nevű fájl tartalmát dinamikus tömbbe olvassa be, és azt visszaadja.
A függvény feladata a két méret visszaadása is paraméterlistán.
*/
int* read_seats(char* filename, int* rows, int* cols) {     
    FILE* f = fopen(filename, "rb");                        
    fread(rows, sizeof(int), 1, f);                         
    fread(cols, sizeof(int), 1, f);
    int* seats = (int*)malloc(sizeof(int) * (*rows * *cols));
    int e = fread(seats, sizeof(int), *rows * *cols, f);    
    fclose(f);
    return seats;
}

/*
b) Írj függvényt, mely meghatározza, hogy egy kiválasztott sorban lefoglalható-e egymás mellett $k$ darab szék.
A függvény kapja paraméterként a dinamikus tömböt és annak két méretét, a kiválasztott sor sorszámát (1-től indul), valamint a lefoglalandó székek $k$ számát.
Ha sikerül a foglalás, a függvény adja vissza a legelső lefoglalt szék sorszámát (1-ről indul), és ekkor módosítsa is a foglaltsági tömböt.
Ha nem, visszatérési értéke legyen -1.
A függvény az üres blokkot a sor első székétől keresi, és az első adandó alkalommal visszatér.
*/
int reserve(int* seats, int rows, int cols, int row, int k) {   
    int c = 0;
    for (int i = (row - 1) * cols; i < row * cols; i++) {       
        if (seats[i] == 0)                                      
            c++;
        else 
            c = 0;
        if (c == k) {
            for (int j = 0; j < k; j++)                        
                seats[i - j] = 1;
            return (i - (k - 1) + 1) % cols;                
        }
    }
    return -1;
}